/*
  CPP_CONTEST=2013Cal-2011
  CPP_PROBLEM=F
  CPP_LANG=C+OPENMP+MPI
  CPP_PROCESSES_PER_NODE=marte 6 mercurio 6
*/

/* RECORD
Carlos Hoyos Barcelo
student of Algorithms and Parallel Programming,
at the Unviersity of Murcia, Spain
March 19, 2012
time 468 msec
speed-up 36.59
*/

/*RECORD in the new system
when the programs in the record table are run in the new system
formed by marte+mercurio (two hexacores),
it is the absolute record, with
time 1212
speed-up 11.06
*/

//#ifdef DEBUG
//#endif
#include <stdlib.h>
#include <stdio.h>
#include <mpi.h>

//descomentar la linea de abajo si el programa falla por no reconocer MPI_IN_PLACE
//#define OLDMPI

void copiar(int t,char *o,char *d)
{
  int i;

  for(i=0;i<(t-8);i+=8) {
    d[i]=o[i];d[i+1]=o[i+1];d[i+2]=o[i+2];d[i+3]=o[i+3];
    d[i+4]=o[i+4];d[i+5]=o[i+5];d[i+6]=o[i+6];d[i+7]=o[i+7];
  }
  for(i=0;i<t;i++) {
    d[i]=o[i];
  }
}

//metodo que calcula el numero de vecinos que le corresponden a una celda
//para una posicion, tamaño de matriz cuadrada, y tamaño vencindario dados
//la celda no se cuenta a si misma como vecino
int numvecinos(int alto, int ancho,int fila,int columna,int area) {
  int inicol,fincol,inifil,finfil;
  int dist_esquina;
  int huecos=0;

  inicol=(columna<=area)?0:columna-area;
  fincol=columna+area;
  if (fincol>=ancho) fincol=ancho-1;
  inifil=(fila<=area)?0:fila-area;
  finfil=fila+area;
  if (finfil>=alto) finfil=alto-1;
 
  //esquina superior izquierda
  dist_esquina=fila-inifil+columna-inicol;
  if (dist_esquina>area) huecos+=((dist_esquina-area)*(dist_esquina-area+1))>>1;
  //esquina inferior izquierda
  dist_esquina=finfil-fila+columna-inicol;
  if (dist_esquina>area) huecos+=((dist_esquina-area)*(dist_esquina-area+1))>>1;
  //esquina superior derecha
  dist_esquina=fila-inifil+fincol-columna;
  if (dist_esquina>area) huecos+=((dist_esquina-area)*(dist_esquina-area+1))>>1;
  //esquina inferior derecha
  dist_esquina=finfil-fila+fincol-columna;
  if (dist_esquina>area) huecos+=((dist_esquina-area)*(dist_esquina-area+1))>>1;
  return ((fincol-inicol+1)*(finfil-inifil+1)-(huecos+1));
}

char valorborde(int alto, int ancho,char *a,int fila, int columna,int vecindad,int min,int max)
{
  int i,j,izq,der,sup;
  int contuno=0,enough=max>>1;

#ifdef DEBUG
  printf("FILA y COLUMNA: %d %d: \n",fila,columna);
#endif

// Se cuenta el número de unos y de vecinos en filas anteriores, sin salir del tablero
  for(i=fila-1;i>=((fila-vecindad)>0?(fila-vecindad):0);i--)
  {
    izq=columna-vecindad+fila-i;
    izq=(izq>0?izq:0);
    der=columna+vecindad-fila+i;
    der=(der<ancho?der:(ancho-1));

    for(j=izq;j<=der;j++)
    {
      if(a[i*ancho+j]==1)
        contuno++;
    }
  }
  if (contuno>=enough) return 1;

#ifdef DEBUG
  printf("     unos en la parte anterior: %d \n",contuno);
#endif
// se acumula el número de unos y de vecinos en la misma fila, columnas anteriores, sin salir del tablero
  for(j=((columna-vecindad)>0?(columna-vecindad):0);j<columna;j++)
  {
    {
      if(a[fila*ancho+j]==1)
        contuno++;
    }
  }

  if (contuno>=enough) return 1;
#ifdef DEBUG 
  printf("     unos antes e izquierda: %d \n",contuno);
#endif
// se acumula el número de unos y de vecinos en la misma fila, columnas posteriores, sin salir del tablero
  der=((columna+vecindad)<ancho?(columna+vecindad):(ancho-1));
  for(j=columna+1;j<=der;j++)
  {
    {
      if(a[fila*ancho+j]==1)
        contuno++;
    }
  }

  if (contuno>=enough) return 1;
  
#ifdef DEBUG 
  printf("     unos arriba, izq y derecha: %d \n",contuno);
#endif
// se acumula el número de unos y de vecinos en filas posteriores, sin salir del tablero
  sup=((fila+vecindad)<alto?(fila+vecindad):(alto-1));
  for(i=fila+1;i<=sup;i++)
  {
    izq=columna+i-fila-vecindad;
    izq=(izq>0?izq:0);
    der=columna-i+fila+vecindad;
    der=(der<ancho?der:(ancho-1));
#ifdef DEBUG
    printf(" ( %d %d %d )\n",i,izq,der);
#endif
    for(j=izq;j<=der;j++)
    {
      if(a[i*ancho+j]==1)
        contuno++;
    }
    if (contuno>=enough) return 1;
  }

#ifdef DEBUG 
  printf("     unos arriba, izq, der y arriba: %d \n",contuno);
#endif
  contuno=contuno<<1;
  if (contuno<min)
  {
#ifdef DEBUG
    printf("  unos, total, valor: %d %d 0\n",contuno,cont);
#endif
    return 0;
  }

  return ((char)(contuno>=numvecinos(alto,ancho,fila,columna,vecindad)));
} //fin valorborde

//version de valor para elementos que estan en el centro del tablero
char valorcentro(int alto,int ancho,char *a,int fila, int columna,int vecindad,int max)
{
  int i,j;
  int contuno=0,enough=max>>1;

// Se cuenta el número de unos y de vecinos en filas anteriores
  for(i=fila-1;i>=fila-vecindad;i--)
  {
    for(j=columna-vecindad+fila-i;j<=columna+vecindad-fila+i;j++)
    {
      if(a[i*ancho+j]==1)
        contuno++;
    }
  }
  if (contuno>=enough) return 1;
  
// se acumula el número de unos y de vecinos en la misma fila, columnas anteriores
  for(j=columna-vecindad;j<columna;j++)
  {
    if(a[fila*ancho+j]==1)
      contuno++;
  }

  if (contuno>=enough) return 1;

// se acumula el número de unos y de vecinos en la misma fila, columnas posteriores
  for(j=columna+1;j<=columna+vecindad;j++)
  {
    if(a[fila*ancho+j]==1)
      contuno++;
  }

  if (contuno>=enough) return 1;
  
// se acumula el número de unos y de vecinos en filas posteriores
  for(i=fila+1;i<=fila+vecindad;i++)
  {
    for(j=columna+i-fila-vecindad;j<=columna-i+fila+vecindad;j++)
    {
      if(a[i*ancho+j]==1)
        contuno++;
    }
    if (contuno>=enough) return 1;
  }
  return 0;
} //fin valorborde


//metodo alternativo a allgather para la version LAM MPI 1.4.2
void migather(int nodo, int np, char *a, char *porcion, int *tamporcionp, int *despp) {
  int i;
  MPI_Request r;
  MPI_Status stats;
  if (nodo==0) {
    MPI_Isend(porcion, tamporcionp[0], MPI_CHAR, 0, 50, MPI_COMM_WORLD, &r);
    for (i=0;i<np;i++) {
      MPI_Recv(&a[despp[i]], tamporcionp[i], MPI_CHAR, i, 50, MPI_COMM_WORLD, &stats);
    }
    MPI_Wait(&r,&stats);
  } else {
    MPI_Send(porcion, tamporcionp[nodo], MPI_CHAR, 0, 50, MPI_COMM_WORLD);
  }
} //fin migather

//######################
//## Metodo principal ##
//######################
void sec(int t,char *a,int vecmax,int iter,int nodo,int np)
{
  int niter,i,j,k; 
  int lineas;
  int offset;
  int dist;
  int min,max;
  int *despp; //tabla para la funcion gatherv
  int *tamporcionp; //tabla para la funcion gatherv
  char *porcion; //porcion de la tabla que actualiza cada proceso 
  char *buffer; //ventana auxiliar para las iteraciones pares
  int tamventana;
  char *ventana; //seccion de la tabla que un proceso es capaz de ver
  int vecinoini, vecinofin; //vecinos a los que enviar y recibir datos
  MPI_Status stats;
  MPI_Request *envio_ok,*recibo_ok; //para comprobar que se han actualizado los vecinos
  
  MPI_Bcast(&t,1,MPI_INT,0,MPI_COMM_WORLD);

  lineas=t/np+((nodo<(t%np))?1:0); //porcion de trabajo que cada proceso debe procesar de la tabla
  offset=(t/np*nodo)+((nodo<=(t%np))?nodo:(t%np)); //linea de la tabla donde empieza la porcion que corresponde al proceso

  MPI_Alloc_mem(sizeof(int)*np,MPI_INFO_NULL,&tamporcionp);//tamporcionp=(int*)calloc(sizeof(int),np);//
  MPI_Alloc_mem(sizeof(int)*np,MPI_INFO_NULL,&despp);//despp=(int*)calloc(sizeof(int),np);//

  MPI_Bcast(&vecmax,1,MPI_INT,0,MPI_COMM_WORLD);  
  MPI_Bcast(&iter,1,MPI_INT,0,MPI_COMM_WORLD);  

  if ((i=offset-vecmax)<0) i=0;
  if ((j=offset+lineas+vecmax-(lineas!=0))>(t-1)) j=t-1;

  vecinofin=np-1;
  //colecciones para gatherv (probablemente mas eficiente calcular cada uno, que enviarse los datos)
  for (k=0;k<(t%np);k++) {
    tamporcionp[k]=(t/np+1);
    despp[k]=((t/np*k)+k);
    if (despp[k]>t) despp[k]=t;
    //se establecen las medidas de la ventana
    if ((despp[k]<=i)&&(despp[k]+tamporcionp[k]>i)) vecinoini=k;
    if ((despp[k]<=j)&&(despp[k]+tamporcionp[k]>j)) vecinofin=k;
    tamporcionp[k]*=t;
    despp[k]*=t;
  }

  for (;k<np;k++) {
    tamporcionp[k]=(t/np);
    despp[k]=((t/np*k)+(t%np));
    if (despp[k]>t) despp[k]=t;
    //se establecen las medidas de la ventana
    if ((despp[k]<=i)&&(despp[k]+tamporcionp[k]>i)) vecinoini=k;
    if ((despp[k]<=j)&&(despp[k]+tamporcionp[k]>j)) vecinofin=k;
    tamporcionp[k]*=t;
    despp[k]*=t;
  }

//  if vecinofin>t-1
  if (np>=t) {
    for (k=t;k<np;k++) {
      tamporcionp[k]=0;
      despp[k]=t*t;
    }
    //si hay mas nodos que lineas en la tabla, se quedan ociosos
    if (nodo>=t) {
      vecinoini=nodo;
      vecinofin=nodo;
    }
  }

  tamventana=despp[vecinofin]-despp[vecinoini]+tamporcionp[vecinofin];

    //se reserva espacio para enviar la porcion del nodo a sus vecinos
    k=vecinofin-vecinoini;//+1;
    if (k<0) k=0;
    MPI_Alloc_mem(sizeof(MPI_Request)*k,MPI_INFO_NULL,&envio_ok);  //para saber si el envio se completo
    MPI_Alloc_mem(sizeof(MPI_Request)*k,MPI_INFO_NULL,&recibo_ok); //para saber si se recibio la porcion

  //se pasa a cada proceso la parte de la matriz A que necesita para trabajar
  if (nodo==0) {
    ventana=a;
    MPI_Alloc_mem(sizeof(char)*tamventana,MPI_INFO_NULL,&buffer); //ventana para iteraciones pares
    porcion=buffer;
    copiar(lineas*t,ventana,porcion);
    if (np>1) {
      for (i=1;i<np;i++) {
        MPI_Send(&a[despp[i]],tamporcionp[i],MPI_CHAR,i,50,MPI_COMM_WORLD); //envia su porcion de tabla a
      }
      MPI_Barrier(MPI_COMM_WORLD);
    }
  } else {
    //se reserva espacio para la ventana (porcion de la tabla que el proceso es capaz de ver)
    MPI_Alloc_mem(sizeof(char)*tamventana,MPI_INFO_NULL,&ventana);
    MPI_Alloc_mem(sizeof(char)*tamventana,MPI_INFO_NULL,&buffer);
    porcion=&ventana[despp[nodo]-despp[vecinoini]];
    //recibe la porcion de trabajo que le corresponde
    MPI_Recv(porcion,tamporcionp[nodo],MPI_CHAR,0,50,MPI_COMM_WORLD,&stats);

    MPI_Barrier(MPI_COMM_WORLD);
  }

 
  offset=(despp[nodo]-despp[vecinoini])/t;

  // Se realizan las iteraciones
  for(niter=0;niter<iter;niter++)
  {
    dist=(niter%vecmax)+1;

    //esta parte solo se hace si hay mas de un proceso, para optimizar
    if (np>1) {
      //cada proceso envia su porcion a los demas procesos (incluido el)
      k=(lineas<dist)?lineas:dist;
      for (i=vecinoini;i<nodo;i++) {
        //mejora: ahora envia solo las lineas que el vecino puede necesitar
        //enviar mensaje con isend a los vecinos 
        MPI_Isend(porcion, k*t, MPI_CHAR, i, 50, MPI_COMM_WORLD, &envio_ok[i-vecinoini]);
      }
      for (i=nodo+1;i<=vecinofin;i++) {
        //enviar mensaje con isend a los vecinos 
        MPI_Isend(&porcion[(lineas-k)*t], k*t, MPI_CHAR, i, 50, MPI_COMM_WORLD, &envio_ok[i-vecinoini-1]);
      }
      //cada proceso recibe la porcion de sus vecinos 
      for (i=vecinoini;i<nodo;i++) {
        k=tamporcionp[i]-dist*t;
        k=(k>0)?k:0;
        MPI_Irecv(&ventana[(despp[i]-despp[vecinoini]+k)], tamporcionp[i], MPI_CHAR, i, 50, MPI_COMM_WORLD, &recibo_ok[i-vecinoini]);
      }
      for (i=nodo+1;i<=vecinofin;i++) {
//        k=(tamporcionp[i]<(dist*t))?tamporcionp[i]:(dist*t); //no hace falta porque no hay problema si espera recibir mas de lo que le llega
        MPI_Irecv(&ventana[(despp[i]-despp[vecinoini])], tamporcionp[i], MPI_CHAR, i, 50, MPI_COMM_WORLD, &recibo_ok[i-vecinoini-1]);
      }

      //ahora se comprueba que se recibieron todas las porciones
      for (i=0;i<(vecinofin-vecinoini);i++) {
        MPI_Wait(&recibo_ok[i],&stats);
      }

    } //fin de las comunicaciones

    //calculos que se sacan del bucle principal
    min=numvecinos(tamventana/t, t,0,0,dist);
    min=(min>>1)+(min%2); //vecinos activos necesarios para que celula viva si esta tiene el maximo numero de vecinos
    max=(dist*(dist+1))<<1;//4*((dist)*(dist+1)/2)

    //comprobar que se enviaron todos los mensajes a los vecinos antes de modificar los datos
    if (np>1) {
      for (i=nodo;i<(vecinofin-vecinoini);i++) {
        MPI_Wait(&envio_ok[i],&stats);
      }
    } //fin de comprobacion

    //los datos se actualizan en la otra ventana para no machacar los datos actuales
    porcion=&buffer[despp[nodo]-despp[vecinoini]];
    //#pragma omp parallel for private(i,j) shared(a,b,t,vecmax,niter) schedule(dynamic,2)

    k=tamventana/t;
    for (i = 0; i < lineas; i++) 
    {
        if (i+offset<dist||i+offset>=k-dist) 
        {
          for (j=0;j<(t-8);j+=8)
          {
           // Cada elemento se obtiene contando los unos en su vecindad,
            // con tamaño de la vecindad determinado por la iteración y la vecindad máxima: 1, 2, ... ,vecmax , 1, 2 ...
            porcion[i*t+j]=valorborde(k,t,ventana,i+offset,j,dist,min,max);
            porcion[i*t+j+1]=valorborde(k,t,ventana,i+offset,j+1,dist,min,max);
            porcion[i*t+j+2]=valorborde(k,t,ventana,i+offset,j+2,dist,min,max);
            porcion[i*t+j+3]=valorborde(k,t,ventana,i+offset,j+3,dist,min,max);
            porcion[i*t+j+4]=valorborde(k,t,ventana,i+offset,j+4,dist,min,max);
            porcion[i*t+j+5]=valorborde(k,t,ventana,i+offset,j+5,dist,min,max);
            porcion[i*t+j+6]=valorborde(k,t,ventana,i+offset,j+6,dist,min,max);
            porcion[i*t+j+7]=valorborde(k,t,ventana,i+offset,j+7,dist,min,max);
          }
          for (;j<t;j++) {
            porcion[i*t+j]=valorborde(k,t,ventana,i+offset,j,dist,min,max);
          }
        }
        else
        {
          for (j=0;j<(t-8);j+=8)
          {
            if (j>=dist&&(j+7<t-dist)) {
              porcion[i*t+j]=valorcentro(k,t,ventana,i+offset,j,dist,max);
              porcion[i*t+j+1]=valorcentro(k,t,ventana,i+offset,j+1,dist,max);
              porcion[i*t+j+2]=valorcentro(k,t,ventana,i+offset,j+2,dist,max);
              porcion[i*t+j+3]=valorcentro(k,t,ventana,i+offset,j+3,dist,max);
              porcion[i*t+j+4]=valorcentro(k,t,ventana,i+offset,j+4,dist,max);
              porcion[i*t+j+5]=valorcentro(k,t,ventana,i+offset,j+5,dist,max);
              porcion[i*t+j+6]=valorcentro(k,t,ventana,i+offset,j+6,dist,max);
              porcion[i*t+j+7]=valorcentro(k,t,ventana,i+offset,j+7,dist,max);
            } else {
              porcion[i*t+j]=(j<dist||j>=t-dist)?valorborde(k,t,ventana,i+offset,j,dist,min,max):valorcentro(k,t,ventana,i+offset,j,dist,max);
              porcion[i*t+j+1]=(j+1<dist||j+1>=t-dist)?valorborde(k,t,ventana,i+offset,j+1,dist,min,max):valorcentro(k,t,ventana,i+offset,j+1,dist,max);
              porcion[i*t+j+2]=(j+2<dist||j+2>=t-dist)?valorborde(k,t,ventana,i+offset,j+2,dist,min,max):valorcentro(k,t,ventana,i+offset,j+2,dist,max);
              porcion[i*t+j+3]=(j+3<dist||j+3>=t-dist)?valorborde(k,t,ventana,i+offset,j+3,dist,min,max):valorcentro(k,t,ventana,i+offset,j+3,dist,max);
              porcion[i*t+j+4]=(j+4<dist||j+4>=t-dist)?valorborde(k,t,ventana,i+offset,j+4,dist,min,max):valorcentro(k,t,ventana,i+offset,j+4,dist,max);
              porcion[i*t+j+5]=(j+5<dist||j+5>=t-dist)?valorborde(k,t,ventana,i+offset,j+5,dist,min,max):valorcentro(k,t,ventana,i+offset,j+5,dist,max);
              porcion[i*t+j+6]=(j+6<dist||j+6>=t-dist)?valorborde(k,t,ventana,i+offset,j+6,dist,min,max):valorcentro(k,t,ventana,i+offset,j+6,dist,max);
              porcion[i*t+j+7]=(j+7<dist||j+7>=t-dist)?valorborde(k,t,ventana,i+offset,j+7,dist,min,max):valorcentro(k,t,ventana,i+offset,j+7,dist,max);
            }
          }
          for (;j<t;j++)
          {
            porcion[i*t+j]=valorborde(k,t,ventana,i+offset,j,dist,min,max);
          }

        }
    } //fin bucle principal

    //esta MPI_Barrier se puede activar si hay resultados incorrectos
//      MPI_Barrier(MPI_COMM_WORLD);
    //se intercambian los punteros de las ventanas
      char *temp=ventana;
      ventana=buffer;
      buffer=temp;
      porcion=&ventana[despp[nodo]-despp[vecinoini]];

  } //fin iteraciones del algoritmo

  if (np==1) {
    if((iter%2)==1)
    {
      copiar(t*t,ventana,buffer);
      a=buffer;
      buffer=ventana;
    }
  } else {
    if ((iter%2)==0) {
      #ifndef OLDMPI
      if(nodo==0) MPI_Gatherv(MPI_IN_PLACE, 0, MPI_DATATYPE_NULL, a, tamporcionp, despp, MPI_CHAR,0, MPI_COMM_WORLD);  
      else
      #endif
      //usar migather en vez de MPI_Gatherv si hay resultados incorrectos por el bug de LAM/MPI 1.4.2
//    migather(nodo, np, a, porcion, tamporcionp, despp);
      MPI_Gatherv(porcion, lineas*t, MPI_CHAR, a, tamporcionp, despp, MPI_CHAR,0, MPI_COMM_WORLD);  
    } else {

      MPI_Gatherv(porcion, lineas*t, MPI_CHAR, a, tamporcionp, despp, MPI_CHAR,0, MPI_COMM_WORLD);  
    }
  }

  if (nodo==0) {
    if (iter%2==0) {
      MPI_Free_mem(buffer);
    } else {
      MPI_Free_mem(ventana);
    }
  } else {
    MPI_Free_mem(ventana);  
    MPI_Free_mem(buffer);
  }
  MPI_Free_mem(tamporcionp);
  MPI_Free_mem(despp);
  MPI_Free_mem(envio_ok); 
  MPI_Free_mem(recibo_ok); 
}
